local min_health = 0.04

function OnWorldPreUpdate()
	local player_id = EntityGetWithTag("player_unit")[1]
	if player_id == nil then
		return
	end

	local player_damage_model_id = EntityGetFirstComponent(player_id, "DamageModelComponent")
	if player_damage_model_id == nil then
		return
	end
	
	local health = tonumber(ComponentGetValue(player_damage_model_id, "hp"))
	if health < min_health then
	
		-- get current lives
		local lives = tonumber(GlobalsGetValue("lives", 0))
		
		-- only respawn the player if he has not finished the game and has lives remaining
		if lives > 0 and not GameHasFlagRun( "ending_game_completed" ) then
			local max_hp = tonumber(ComponentGetValue(player_damage_model_id, "max_hp"))
	
			-- move player to respawn position
			EntitySetTransform(player_id, GlobalsGetValue("spawn_x", 227), GlobalsGetValue("spawn_y", -85))
	
			-- reduce lives, restore HP and spell casts
			lives = lives - 1
			ComponentSetValue(player_damage_model_id, "hp", max_hp)
			GameRegenItemActionsInPlayer(player_id)
			GamePrintImportant("Respawned", "Remaining lives: " .. lives)
	
			-- update life count
			GlobalsSetValue("lives", lives)
		else
			-- kill the player
			ComponentSetValue(player_damage_model_id, "kill_now", "1")
		end
	end
end

function OnPlayerSpawned(player_entity) 

	-- output remaining lives
	GamePrint("Remaining lives: " .. tostring(GlobalsGetValue("lives", 0)))
	
	local player_damage_model_id = EntityGetFirstComponent(player_entity, "DamageModelComponent")
	
	-- disable death
	ComponentSetValue(player_damage_model_id, "wait_for_kill_flag_on_death", "1") 
end